# My2to3

This documentation is rudimentary.

## Apply "trace" fixers on the fly

* When importing modules:
  
  ```python
  from my2to3.trace import patch_imports
  
  def is_whitelisted(fullname, path):
    # This function is used to whitelist specific modules. This corresponds to
    # https://www.python.org/dev/peps/pep-0302/.
    return True
  
  patch_imports(is_whitelisted)
  ```

* On more complex components (i.e. with monkey-patching)
  
  ```python
  from my2to3.trace import tracing_functions, apply_fixers
  
  # `tracing_function` contains all the functions registered with
  # `@register_tracing_function`. Add its content to the builtins (or
  # equivalent) of the component to monkey-patch, e.g.:
  component_builtins.update({f.__name__: f for f in tracing_functions})
  
  # `name` must be a unique name which represents the code to modify, to easily
  # recognize it. In general, we use a filepath (or an equivalent). This is used
  # by the fixers.
  component_code = apply_fixers(component_code, name)
  ```
