from lib2to3.tests.test_fixers import FixerTestCase as lib2to3FixerTestCase
import sqlite3

from my2to3.trace import database, get_data, tracing_functions


class FixerTestCase(lib2to3FixerTestCase):
  # Subclass to replace "fixer_pkg"
  def setUp(self, fix_list=None, fixer_pkg="my2to3", options=None):
    super(FixerTestCase, self).setUp(fix_list, fixer_pkg, options)

    # Clear the database
    # XXX: a better way probably exists.
    # TODO:
    # - refactor
    # - optimize
    conn = sqlite3.connect(database)
    c = conn.cursor()
    for table in c.execute("SELECT name FROM sqlite_master WHERE type='table'").fetchall():
      c.execute("DELETE FROM %s" % table)
    conn.commit()
    conn.close()

  def assertDataEqual(self, table, data):
    self.assertEqual(get_data(table), data)

  def exec_code(self, string):
    exec(compile(string, "<string>", 'exec'), {f.__name__: f for f in tracing_functions})
